SystemOrganization addCategory: #BinaryModules!

TestCase subclass: #BMImageSegmentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BinaryModules'!

!BMImageSegmentTest methodsFor: 'as yet unclassified' stamp: 'lw 12/21/2012 16:33'!
testImageSegmentExport
	
	"copy class GunieaPig"
	
	"export the copy"
	ImageSegment new
		copyFromRoots: (Array with: GunieaPig) sizeHint: 1000;
		writeForExport: 'GunieaPig'.
	
	"remove the copy"
	
	"fileIn and test equality of the saved copy"
	
	"remove the copy"! !

!BMImageSegmentTest methodsFor: 'as yet unclassified' stamp: 'lw 12/21/2012 16:29'!
testImageSegmentSwapping
	
	self assert: GunieaPig isInMemory.
	ImageSegment new
		copyFromRoots: (Array with: GunieaPig) sizeHint: 1000;
		extract.

	self deny: GunieaPig isInMemory.
	GunieaPig xxxSegment install.
	self assert: GunieaPig isInMemory.
! !

!MultiByteFileStream methodsFor: '*BinaryModules' stamp: 'lw 12/21/2012 14:52'!
nextPutAll: aCollection

	(self isBinary or: [aCollection class == ByteArray]) ifTrue: [
		^ super nextPutAll: aCollection.
	].
	aCollection class == WordArrayForSegment ifTrue: [
		^ super nextPutAll: (Bitmap withAll: aCollection) asByteArray
	].
	^converter nextPutAll: aCollection toStream: self! !

Object subclass: #GunieaPig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BinaryModules'!

!GunieaPig methodsFor: 'mistreat' stamp: 'lw 12/21/2012 16:18'!
feedPills
	^ #( die turnYellow turnGreen heal '' ) atRandom! !

!GunieaPig methodsFor: 'treat' stamp: 'dg 12/21/2012 16:25'!
pet
	
	^#purr
	! !

!GunieaPig methodsFor: 'mistreat' stamp: 'lw 12/21/2012 16:13'!
poke
	^ #bite! !

!GunieaPig methodsFor: 'mistreat' stamp: 'lw 12/21/2012 16:17'!
stab
	^#die! !

ImageSegment subclass: #BMImageSegment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BinaryModules'!

!BMImageSegment methodsFor: 'read/write segment' stamp: 'lw 12/21/2012 16:10'!
install
	[^super install] ifError: [self halt.]! !
